import td from './td'

let tMobileSDK = window.tMobileSDK || {}

tMobileSDK.configs = {
    headerType: 'wx-footer',
    hasBuildFunc: false
}

tMobileSDK.util = {
    eval: function(expression){
        try {
            eval(expression)
        } catch(error) {
            console.error(error.message)
        }
    }
}

tMobileSDK.collectInfo = function(url){
    if(!url){
        return    
    }
    var params = {}
    
    if(navigator.userAgent){
        params.ua = navigator.userAgent
    }
    if(window.screen){
        params.sw = window.screen.width
        params.sh = window.screen.height
    }
    if(window.location){
        params.host = window.location.host
        params.url = window.location.href
    }
    params.platform = this.platForm || ''
    
    
    try{
        var timing = performance.timing.toJSON()
        var result = {}
        for(var key in timing){
            if(timing[key]){
                result[key] = timing[key]
            }
        }
        params.timing = JSON.stringify(result)
    }catch(e){}
    
    
    var args = ''
    for(var i in params) {
        if(args !== '') {
            args += '&'
        }   
        args += i + '=' + encodeURIComponent(params[i])
    }

    var img = new Image(1,1)
    img.src = url + '?' + args
} 

tMobileSDK.module2icon = function(module){
    var host = location.origin
    var url = host + '/static/images/mobile_app/{module}.png'.replace(/{module}/i, module)
    return url
}

tMobileSDK.ready = function(func){
    td.ready(func)
}

tMobileSDK.confirm = function(opts) {
    td.confirm({
        title: opts.title || '提示',
        message: opts.message || '',
        buttonLabels: opts.buttonLabels || ['确定','取消'],
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.toast = function(opts) {
    td.toast({
        text: opts.text || '',
        duration: opts.duration || 5,
        delay: opts.delay || 0,
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.getLocation = function(opts) {
    td.getLocation({
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.previewImage = function(opts) {

    opts.urls.forEach(function(v, k){
        opts.urls[k] = tMobileSDK.addAuthCode(v)
    })
    opts.current = tMobileSDK.addAuthCode(opts.current)

    td.previewImage({
        urls: opts.urls || [],
        current: opts.current || 0,
		allowDownload: opts.allowDownload,
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.launchApp = function(opts) {
    td.launchApp({
        app: opts.app || '',
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.previewFile = function(opts) {
    td.previewFile({
        url: opts.url || '',
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.call = function(opts) {
    td.call({
        phoneNum: opts.phoneNum || '',
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.sendMessage = function(opts) {
    td.sendMessage({
        phoneNums: opts.phoneNums || [''],
        content: opts.content || '',
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.getNetworkType = function(opts) {
    td.getNetworkType({
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.chooseImage = function(opts) {
    td.chooseImage({
        multiple: opts.multiple,
        max: opts.max,
        fromCamera: opts.fromCamera || false,
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.uploadImage = function(opts) {
    this.chooseImage({
        multiple: opts.multiple,
        max: opts.max,
        onSuccess: function(data) {
            opts.upSuccessCb && opts.upSuccessCb(data)
        },
        onFail: function(e) {
            opts.upErrorCb && opts.upErrorCb()
        }
    })
}

tMobileSDK.selectFile = function(opts) {
    td.selectFile({
        multiple: opts.multiple,
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.selectUser = function(opts) {
    td.selectUser({
		multiple: opts.multiple,
        users: opts.users,
		usableUids: opts.usableUids,
		checkedAll: opts.checkedAll,
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.selectDept = function(opts) {
    td.selectDept({
		multiple: opts.multiple,
        depts: opts.depts,
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.setLeft = function(opts) {
    td.setLeft({
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.setTitle = function(opts) {
    td.setTitle({
        title: opts.title || '标题',
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })

}

tMobileSDK.setRight = function(opts) {
    td.setRight({
        show: opts.show || true,
        control: opts.control || false,
        text: opts.text || '',
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.actionSheet = function(opts) {
    td.actionSheet({
        title: opts.title || '标题',
        cancelButton: opts.cancelButton || '取消',
        otherButtons: opts.otherButtons || ['btn1','btn2'],
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.buildHeader = function(headerData) {
    var hash = {}
    var title = []
    if(headerData.c && headerData.c.push) {
        headerData.c.forEach(function(item, index) {
            title.push({
                title: item.title,
                active: item.active
            })
            hash[index] = item.event
        })
    } else if(headerData.c) {
        title.push(headerData.c.title)
    }
    headerData.c && this.setTitle({
        title: title,
        onSuccess: function(results) {
            if(results) {
                tMobileSDK.util.eval(hash[results])
            }
        }
    })
    if(headerData.r === null) headerData.r = {}
    headerData.r && this.setRight({
        show: true,
        control: true,
        text: headerData.r.title,
        onSuccess: function(results) {
            if(results === 'clicked') {
                headerData.r.event && tMobileSDK.util.eval(headerData.r.event)
            }
        }
    })
    if(headerData.l === null) headerData.l = {}
	headerData.l && this.setLeft({
		onSuccess: function(results) {
			headerData.l.event && tMobileSDK.util.eval(headerData.l.event)
		}
	})   
}

tMobileSDK.buildFunc = function(funcData) {
    var hash = {}
    var otherButtons = []
    funcData.forEach(function(item, index) {
        hash[index] = item.event
        otherButtons.push(item.title)
    })
    this.actionSheet({
        title: '选项',
        otherButtons: otherButtons,
        onSuccess: function(results) {
            if(results !== -1) {
                tMobileSDK.util.eval(hash[results])
            }
        }
    })
}

tMobileSDK.closeWebview = function() {
    td.closeWebview()
}

tMobileSDK.ding = function(){}

tMobileSDK.dingBtn = function() {}

tMobileSDK.checkIn = function(opts) {
    td.checkIn({
        locales: opts.locales || [],
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.getMacAddress = function(opts) {
    td.getMacAddress({
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.getLocationByMap = function(opts) {
    td.getLocationByMap({
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.getLocationOutside = function(opts) {
    td.getLocationOutside({
        onSuccess: opts.onSuccess,
        onFail: opts.onFail
    })
}

tMobileSDK.addAuthCode = function(url){
    return url
}
